#include <iostream>
#include <sstream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cctype>
#include <string>
#include <vector>
#include <list>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>
using namespace std;

#define DEBUG(x) cout << '>' << #x << ':' << x << endl;
#define FOR(i, b) for (i=0 ; i < (b); ++i)
#define FOR2(i, a, b) for (int i = (a); i > (b); --i)
inline bool EQ(double a, double b) { return fabs(a-b) < 1e-9; }

const int INF = 1<<29;
typedef long long ll;

int N,M,a[111][111];
char m[111][111],res[111][111];

bool bad(int x,int y){ return (x<0||y<0||x==N||y==M||m[x][y]!='.'); }
bool bad2(int x,int y){ return (x<0||y<0||x==N||y==M||res[x][y]!='.'); }

bool get(int x,int y){
	if(bad(x,y)) return true;
	m[x][y]='#';
	bool ans=!get(x-1,y)||!get(x,y-1)||!get(x+1,y)||!get(x,y+1);
	m[x][y]='.';
	return ans;
}

int around(int x,int y){
	return 4-(bad(x-1,y)+bad(x+1,y)+bad(x,y-1)+bad(x,y+1));
}

int around2(int x,int y){
	return 4-(bad2(x-1,y)+bad2(x+1,y)+bad2(x,y-1)+bad2(x,y+1));
}

void backtrack(){
	int i,j;
	FOR(i,N){
		FOR(j,M){
			if(m[i][j]=='.'){
				if(get(i,j)) res[i][j]='A';
				else res[i][j]='B';
			}
			else res[i][j]='X';
		}
		res[i][M]='\0';
	}
}

/*
int A,B;

void dfs(int x,int y){
	if(bad2(x,y)) return;
	if((x+y)%2){
		A++;
		res[x][y]='N';
	}
	else{
		B++;
		res[x][y]='M';
	}
	dfs(x-1,y);
	dfs(x+1,y);
	dfs(x,y-1);
	dfs(x,y+1);
}*/

void solve(int x,int y){
	if(res[i][j]!='.') return;
	A=0;
	B=0;
	dfs(x,y);
	int i,j;
	if(A==B||(A%2==0&&B%2==0)){
		FOR(i,N) FOR(j,M) if(res[i][j]=='N'||res[i][j]=='M') res[i][j]='A';
	}
	else{
		if(A>B){
			FOR(i,N) FOR(j,M) if(res[i][j]=='N') res[i][j]='B';
			FOR(i,N) FOR(j,M) if(res[i][j]=='M') res[i][j]='A';
		}
		else{
			FOR(i,N) FOR(j,M) if(res[i][j]=='N') res[i][j]='A';
			FOR(i,N) FOR(j,M) if(res[i][j]=='M') res[i][j]='B';
		}
	}
	FOR(i,N) FOR(j,M){
		if(!bad(i,j)&&a[i][j]==3) res[i][j]='A';
	}
}
/*void haluz(){
	int i,j;
	FOR(i,N) FOR(j,M) res[i][j]=m[i][j];
	FOR(i,N) FOR(j,M) solve(i,j);
}*/

int main() {
	int i,j;
	while(true){
		scanf("%d%d",&N,&M);
		if(N+M==0) break;
		FOR(i,N) scanf("%s",m[i]);
		FOR(i,N) FOR(j,M) a[i][j]=around(i,j);		
		bool change=false;
		while(change){
		FOR(i,N) FOR(j,M){
			if(around2(i,j)==1){
				change=true;
				if(!bad(i-1,j)) res[i-1][j]='A';
				if(!bad(i+1,j)) res[i+1][j]='A';
				if(!bad(i,j-1)) res[i][j-1]='A';
				if(!bad(i,j+1)) res[i][j+1]='A';
			}
		}
		}
		//backtrack();
		solve();
		FOR(i,N){
			res[i][M]='\0';
			printf("%s\n",res[i]);
		}
		printf("\n");
	}	
	return 0;
}

